##
##	PDC1 Parallel Makefile 
##
##
FILE_EXT = sh
##
EXEC = xpdc1.par.$(FILE_EXT)
##
CC = gcc 
##
##To generate power balance dump file uncomment the line below:
##DEFINES = -DPOW
##
##For Optimized Mode uncomment the line below
CFLAGS= -O3 -DMPI_1D
##
##For Debug mode uncomment the line below
##CFLAGS= -g -Wall -DMPI_1D
##
## Flags used for compiling.  -O for optimization, which is optional.
## If the X11 include files are not located in /usr/include/X11, you
## must specify the directory as a flag prefixed by -I.  For instance, 
## if the include files for X11 are located in /usr/local/include, the 
## flag -I/usr/local/include must also be passed.
##
##
MPI_INCLUDE = -I/usr/local/mpich-1.2.0sh/include
MPI_LIBDIR =-L/usr/local/mpich-1.2.0sh/lib
MPI_LIB =-lmpich

XGRAFIX_LIBDIR =-L/usr/local/lib/xgrafix
XGRAFIX_INCLUDE =-I/usr/local/include
XGRAFIX_LIB = -lXGC250P

TCL_LIBDIR = -L/usr/lib
TCL_LIB = -ltk -ltcl

X11_LIBDIR =-L/usr/X11R6/lib
X11_INCLUDE =-I/usr/X11R6/include
X11_LIB = -lX11

XPM_LIB = -lXpm

LIBDIRS = $(MPI_LIBDIR) $(X11_LIBDIR) $(XGRAFIX_LIBDIR) $(TCL_LIBDIR) -L/usr/lib -L/usr/local/lib

LIBS = $(XGRAFIX_LIB) $(XPM_LIB) $(TCL_LIB) $(X11_LIB) $(MPI_LIB) -lm -ldl

INCLUDES = $(MPI_INCLUDE) $(XGRAFIX_INCLUDE)

##
## Libraries and their directories used in loading.  
## Normal is -lm and -lX11 for the Math and X11 libraries, which is 
## NOT optional.  On Unicos, -lnet is also used.  If the X11 
## libraries are not located in /usr/lib/X11, you
## must also specify the directory as a flag prefixed by -L.  
## For instance, if the include files for X11 are located in 
## /usr/local/lib, the flag -L/usr/local/lib must also be passed.  
## On Sun, use -Bstatic to avoid problems with differing versions of OS.  
## Man cc for more information on flags.
##
##
PDC1OBJ=pdc1.o start.o move.o field.o wall.o f_thermal.o frand.o fft.o \
        diagnostics.o mccdiaginit.o initwin.o load.o rescale.o radtr.o \
	maxwellv.o argonmcc_hbs.o argonmcc_lk.o

all:	$(PDC1OBJ) $(EXEC)

.c.o:	pdc1.h
	$(CC) -c $(CFLAGS) $(DEFINES) $(EXTRA_DEFINES) $(INCLUDES) $*.c

$(EXEC):	$(PDC1OBJ)
		$(CC) -o $(EXEC) $(PDC1OBJ) $(LIBDIRS) $(LIBS)

clean:
	@rm -f *.o *~
