#include "pdc1.h"

void mccdiag_init(void)
{
  int i, j;
  
  if(ecollisional==0 && icollisional==0) 
  {
    ncolls = 0;
    return;
  }
  
/* default gas = argon */

  if ( (gas < ARGON_LK) || (gas > ARGON) ) gas = ARGON;

   switch (gas) 
   {
	case ARGON:
	   ncolls= 7;
	   rate_title = (char **)malloc(ncolls*sizeof(char *));
	   rate_title[0]= "MCC Elastic";
	   rate_title[1]= "MCC Excitation";
	   rate_title[2]= "MCC Ionization";
	   rate_title[3]= "MCC Charge X";
	   rate_title[4]= "MCC Scattering";
	   rate_title[5]= "MCC Ionization Ex";
	   rate_title[6]= "MCC Metastable";
	   break;

	case ARGON_LK:
	   ncolls= 7;
	   rate_title = (char **)malloc(ncolls*sizeof(char *));
	   rate_title[0]= "MCC Elastic";
	   rate_title[1]= "MCC Excitation";
	   rate_title[2]= "MCC Ionization";
	   rate_title[3]= "MCC Charge X";
	   rate_title[4]= "MCC Scattering";
	   rate_title[5]= "MCC Ionization Ex";
	   rate_title[6]= "MCC Metastable";
	   break;

  }
  
  /*  Allocate arrays for diagnostic rates */
  Pel       = (SCALAR *)malloc(ng*sizeof(SCALAR));
  Pel_show  = (SCALAR *)malloc(ng*sizeof(SCALAR));
  Pcx       = (SCALAR *)malloc(ng*sizeof(SCALAR));
  Pcx_show  = (SCALAR *)malloc(ng*sizeof(SCALAR));
  Pie       = (SCALAR *)malloc(ng*sizeof(SCALAR));
  Pie_show  = (SCALAR *)malloc(ng*sizeof(SCALAR));
  for (j=0; j<ng; j++) Pel[j] = Pel_show[j] = Pcx[j] = Pcx_show[j] = 
		       Pie[j] = Pie_show[j]=0.0;

  mccrate  = (SCALAR **)malloc(ncolls*sizeof(SCALAR *));
  rate_show= (SCALAR **)malloc(ncolls*sizeof(SCALAR *));
  for(i=0; i<ncolls; i++) 
  {
    mccrate[i]  = (SCALAR *)malloc(ng*sizeof(SCALAR));
    rate_show[i]= (SCALAR *)malloc(ng*sizeof(SCALAR));
    for (j=0; j<ng; j++) mccrate[i][j] = rate_show[i][j] = 0.0;
  }
}
