#include "pdc1.h"

void  calculate_Akm();
SCALAR Ki2(SCALAR), Ki1(SCALAR), zK1(SCALAR), IB1(SCALAR), omega(SCALAR),
      ei1m(SCALAR), GE0(SCALAR), J0(SCALAR);
SCALAR aK1I0(SCALAR, SCALAR), bK0I1(SCALAR, SCALAR), I1(SCALAR),
      phi_integral1(int, int, SCALAR), phi_integral2(int, int, SCALAR);

SCALAR dfreqx, **BB, *Diff, *Diffh, *r_grid2h;
SCALAR Kr=2e-13, Kcq=3e-21, Kiza=6.2e-16;

SCALAR I1_l[7]={ 0.5,        0.87890594, 0.51498869, 0.15084934, 
                0.02658733, 0.00301532, 0.00032411 },
      I1_u[9]={ 0.39894228,-0.03988024,-0.00362018, 0.00163801, -0.01031555, 
                0.02282967,-0.02895312, 0.01787654,-0.00420059 },
      K0_l[7]={-0.57721566, 0.42278420, 0.23069756, 0.03488590,
                0.00262698, 0.00010750, 0.00000740 },
      K0_u[7]={ 1.25331414,-0.07832358, 0.02189568,-0.01062446,
                0.00587872,-0.00251540, 0.00053208 },
      I0_l[7]={ 1.0,        3.5156229,  3.0899424,  1.2067492, 
                0.2659732,  0.0360768,  0.0045813 },
      I0_u[9]={ 0.39894228, 0.01328592, 0.00225319,-0.00157565, 0.00916281,
               -0.02057706, 0.02635537,-0.01647633, 0.00392377 },
      K1_l[7]={ 1.0,        0.15443144,-0.67278579,-0.18156897, 
               -0.01919402,-0.00110404,-0.00004686 },
      K1_u[7]={ 1.25331414, 0.23498619,-0.03655620, 0.01504268,
               -0.00780353, 0.00325614,-0.00068245 },
      K0uI1u[15], K0uI1l[19], I0lI1l[12], K0lI1l[12], 
      K1uI0u[15], K1uI0l[19], I1lI0l[12], K1lI0l[12];

 /************** Initialize Excited State Calculation ***************/
void start_rad()
{
  register int i,j;
  SCALAR dt_drdr, dt_tau, F;
  SCALAR epsi_k, sigma, sigmasq, temp_in_K;
  char filename[20], a_char[80];
  FILE *InputDeck;

  Dr = dr*nc_ratio;
  dt_drdr = dt*sp_k_ex/Dr/Dr;
  dt_tau  = dt*sp_k_ex*A_ki;
#ifdef MPI_1D
  if (my_rank == ROOT) printf("dt/tau=%lf\n",dt_tau);
#else
  printf("dt/tau=%lf\n",dt_tau);
#endif
  dfreqx  = (xmax-xmin)/xbin;
  xbin++;
  interval2=1;			    /* It is for history of t-dep. variables */
  I_factor*=dntod;
  Kr*=dt*dntod;
  Kcq*=dt;
  Kiza*=dt*dntod;

  r_grid2 = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  r_grid2h= (SCALAR *)malloc((nc_RT+1)*sizeof(SCALAR));
  for(j=0; j<nc_RT; j++) r_grid2[j] = (SCALAR)j+0.5;
  for(j=0; j<(nc_RT+1); j++) r_grid2h[j]= (SCALAR)j;
  A     = (SCALAR **)malloc(nc_RT*sizeof(SCALAR *));
  AA    = (SCALAR **)malloc(nc_RT*sizeof(SCALAR *));
  BB    = (SCALAR **)malloc(3 *sizeof(SCALAR *));
  vol2  = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  sp_ex = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  sp_exm= (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  prod  = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  prodm = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  Diff  = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  Diffh = (SCALAR *)malloc((nc_RT+1)*sizeof(SCALAR));
  error = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  E_prod = (SCALAR **)malloc(4*sizeof(SCALAR *));
  ex_ave = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  exm_ave = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  eden_ave = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  ex_mccrate = (SCALAR **)malloc(2*sizeof(SCALAR *));
  ex_ave_show = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  ex_rate_show = (SCALAR **)malloc(2*sizeof(SCALAR *));
  exm_ave_show = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  emission_coeff = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  radiation_flux = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  error_sum=(SCALAR *)malloc(HISTMAX*sizeof(SCALAR));
  t_array3 =(SCALAR *)malloc(HISTMAX*sizeof(SCALAR));
  tot_intensity=(SCALAR *)malloc(HISTMAX*sizeof(SCALAR));
  for (i=0;i<nc_RT;i++) error[i]=0;
  for (i=0;i<HISTMAX;i++) error_sum[i]=0;
  for (i=0;i<4;i++) E_prod[i]=(SCALAR *)malloc(nc_RT*sizeof(SCALAR));

/*  for (i=0;i<nc_RT;i++)
    ng_array[i]=(C1*(i+0.5)*(nc_RT-i-0.5) + N2)/temp;	*/

  I_ave_lhs = (SCALAR *)malloc(xbin*sizeof(SCALAR));
  I_ave_rhs = (SCALAR *)malloc(xbin*sizeof(SCALAR));
  I_ave_lhs_show = (SCALAR *)malloc(xbin*sizeof(SCALAR));
  I_ave_rhs_show = (SCALAR *)malloc(xbin*sizeof(SCALAR));
  x_array=(SCALAR *)malloc(xbin*sizeof(SCALAR));
  L_array=(SCALAR *)malloc(xbin*sizeof(SCALAR));
  intensity_lhs=(SCALAR *)malloc(xbin*sizeof(SCALAR));
  intensity_rhs=(SCALAR *)malloc(xbin*sizeof(SCALAR));

  t_array2=(SCALAR *)malloc(HISTMAX2*sizeof(SCALAR));
  st_nex=(SCALAR **)malloc(HISTMAX2*sizeof(SCALAR *));
  st_nexm=(SCALAR **)malloc(HISTMAX2*sizeof(SCALAR *));
  st_I_lhs=(SCALAR **)malloc(HISTMAX2*sizeof(SCALAR *));
  st_I_rhs=(SCALAR **)malloc(HISTMAX2*sizeof(SCALAR *));
  for(i=0; i< HISTMAX2; i++) {
    st_nex[i]=(SCALAR *)malloc(nc_RT*sizeof(SCALAR));
    st_nexm[i]=(SCALAR *)malloc(nc_RT*sizeof(SCALAR));
    st_I_lhs[i]=(SCALAR *)malloc(xbin*sizeof(SCALAR));
    st_I_rhs[i]=(SCALAR *)malloc(xbin*sizeof(SCALAR));
  }
  for (i=0;i<nc_RT;i++) {
    A [i] = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
    AA[i] = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
    sp_ex[i]=sp_exm[i]=prod[i]=prodm[i]=0;
    vol2[i]=(2*i+1)*nc_ratio*nc_ratio;
  }
  for (i=0;i<3;i++) BB[i] = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  for (i=0;i<2;i++) {
    ex_mccrate[i] = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
    ex_rate_show[i] = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
  }
  switch (lineshape) {
    case LORENTZIAN :
         k_function=lorentz;
         F_factor=I_factor*delta_nu*0.5/Cx*k0;
         break;
    case DOPPLER :
         k_function=doppler;
         F_factor=I_factor*delta_nu/(2*sqrt(log(2)))/Cx*k0;
         break;
    case VOIGT :
         k_function=voigt;
         break;
  }
  for (i=0;i<xbin;i++) {
    x_array[i]=xmin+i*dfreqx;
    L_array[i]=k_function(x_array[i]);
  }
 /************ Diffusion Coefficient **************/
  epsi_k=124.0;				/* for Ar */
  sigma=3.418;				/* for Ar */
  sigmasq=sigma*sigma;
  temp_in_K=11609*T_gas;
  for (i=0;i<nc_RT;i++) {   
    /* For Ar gas */
    Diff[i]=1.997279e-4*sqrt(temp_in_K/39.948)*temp_in_K/
            (pressure*sigmasq*omega(temp_in_K/epsi_k));		
  }   
#ifdef MPI_1D
  if (my_rank == ROOT) 
    printf("pressure=%lf Torr, diff_coeff.=%lf m^2/s\n", pressure, Diff[3]);
#else
  printf("pressure=%lf Torr, diff_coeff.=%lf m^2/s\n", pressure, Diff[3]);
#endif
  for (i=1;i<nc_RT;i++) Diffh[i]=0.5*(Diff[i]+Diff[i-1]);
  Diffh[0]=0;
  Diffh[nc_RT]=Diffh[nc_RT-1];

 /************ Matrix element A_k,m ***************/
#ifdef MPI_1D
 if (my_rank == ROOT) {
  printf("The file name for A_km:"); scanf("%s",filename);
  if ((InputDeck = fopen(filename, "r"))) {
    puts("%%%%%%% Read A_km elements from the file %%%%%%%%");
    while(fscanf(InputDeck,"%lf",&F)<1) fscanf(InputDeck,"%s",a_char);
    for (i=0;i<nc_RT;i++)
      for (j=0;j<nc_RT;j++)
        fscanf(InputDeck,"%lf %lf %lf", &F, &F, &A[i][j]);
    fclose(InputDeck);
  }
 }
#else
  printf("The file name for A_km:"); scanf("%s",filename);
  if ((InputDeck = fopen(filename, "r"))) {
    puts("%%%%%%% Read A_km elements from the file %%%%%%%%");
    while(fscanf(InputDeck,"%lf",&F)<1) fscanf(InputDeck,"%s",a_char);
    for (i=0;i<nc_RT;i++)
      for (j=0;j<nc_RT;j++)
        fscanf(InputDeck,"%lf %lf %lf", &F, &F, &A[i][j]);
    fclose(InputDeck);
  }
#endif
  else {
#ifdef MPI_1D
   if (my_rank == ROOT) {
    printf("read A_km(): file open failed on %s.\n", filename);
    puts("%%%%%%% Calculate A_km elements %%%%%%%%");
   }
#else
    printf("read A_km(): file open failed on %s.\n", filename);
    puts("%%%%%%% Calculate A_km elements %%%%%%%%");
#endif
    calculate_Akm();
  }

 /******** Matrix element AA_k,m and BB_k,m *******/
  for (i=0;i<nc_RT;i++) {
    for (j=0;j<nc_RT;j++) AA[i][j] = dt_tau*A[i][j];
    AA[i][i]-= dt_tau;
    BB[1][i] = - dt_drdr*
               (Diffh[i]*r_grid2h[i]+Diffh[i+1]*r_grid2h[i+1])/r_grid2[i];
    if (i>0)     BB[0][i] = Diffh[i]*r_grid2h[i]/r_grid2[i]*dt_drdr;
    if (i<nc_RT) BB[2][i] = Diffh[i+1]*r_grid2h[i+1]/r_grid2[i]*dt_drdr;
  }
  BB[0][0]=0; BB[2][nc_RT-1]=0;

}
/*******************************************************************/

/*-------------- Evolution of Excited State --------------*/
void excited_evolution()
{
  register int i,j;
  static   int init_flag=1, count3=1, interval3=1;
  static SCALAR *temp, *tempm, *ei_pair, *half_ex, *half_exm, vel;
  SCALAR  Kr_Ne_Nm, Kcq_Ng, Kiza_ex, Kiza_mt;
  int    N_created, no;

  if (init_flag) {
    temp=(SCALAR *)malloc(nc_RT*sizeof(SCALAR));
    tempm=(SCALAR *)malloc(nc_RT*sizeof(SCALAR));
    half_ex=(SCALAR *)malloc(nc_RT*sizeof(SCALAR));
    half_exm=(SCALAR *)malloc(nc_RT*sizeof(SCALAR));
    ei_pair = (SCALAR *)malloc(nc_RT*sizeof(SCALAR));
    init_flag=0;
    vel=1.6241e6;
    hist_hi3=0;
    for (i=0;i<nc_RT;i++) ei_pair[i]=0;
  }

  for (i=0;i<nc_RT;i++) {
    temp[i]=sp_ex[i];
    tempm[i]=sp_exm[i];
  }

  /*  for (i=0; i< nsmoothing; i++) One_2_One(prod, nc_RT-1); 	*/
  /*-------------- Two step calculation ------------------*/
  for (i=0;i<nc_RT;i++) {
    Kr_Ne_Nm=0.5*Kr*eden_ave[i]*tempm[i];
    Kcq_Ng  =0.5*Kcq*gas_den;
    Kiza_ex =Kiza*temp[i]*temp[i];
    Kiza_mt =Kiza*tempm[i]*tempm[i];
    half_ex[i] =temp[i]+prod[i]*0.5;
    half_exm[i]=tempm[i]+prodm[i]*0.5;
    for (j=0;j<nc_RT;j++) half_ex[i]+=0.5*AA[i][j]*temp[j];
    half_ex[i]+=0.5*BB[1][i]*temp[i]; 
    half_exm[i]+=0.5*BB[1][i]*tempm[i];
    if (i>0) {
      half_ex[i]+=0.5*BB[0][i]*temp[i-1]; 
      half_exm[i]+=0.5*BB[0][i]*tempm[i-1];
    }
    if (i<nc_RT-1) {
      half_ex[i]+=0.5*BB[2][i]*temp[i+1]; 
      half_exm[i]+=0.5*BB[2][i]*tempm[i+1];
    }
    half_ex[i] += Kr_Ne_Nm - Kcq_Ng*temp[i] - Kiza_ex;
    half_exm[i]-= Kr_Ne_Nm + Kcq_Ng*tempm[i] + Kiza_mt;
  }
/*  for (i=0;i<nc_RT;i++) half_ex[i]=J0(2.405*(i+0.5)/nc_RT); */
  for (i=0;i<nc_RT;i++) {
    Kr_Ne_Nm=Kr*eden_ave[i]*half_exm[i];
    Kcq_Ng  =Kcq*gas_den;             
    Kiza_ex = Kiza*half_ex[i]*half_ex[i];
    Kiza_mt = Kiza*half_exm[i]*half_exm[i];
    E_prod[1][i]=prod[i]; 
    E_prod[2][i]=E_prod[3][i]=0;

    sp_ex[i]= temp[i]+prod[i];
    sp_exm[i]=tempm[i]+prodm[i]; 
    prod[i]=prodm[i]=eden_ave[i]=0;
    for (j=0;j<nc_RT;j++) sp_ex[i]+=AA[i][j]*half_ex[j];
    sp_ex[i] +=BB[1][i]*half_ex[i]; 
    sp_exm[i]+=BB[1][i]*half_exm[i];
    E_prod[2][i]+=BB[1][i]*half_ex[i]; 
    if (i>0) {
      sp_ex[i] +=BB[0][i]*half_ex[i-1];
      sp_exm[i]+=BB[0][i]*half_exm[i-1];
      E_prod[2][i]+=BB[0][i]*half_ex[i-1];
    }
    if (i<nc_RT-1) {
      sp_ex[i] +=BB[2][i]*half_ex[i+1];
      sp_exm[i]+=BB[2][i]*half_exm[i+1];
      E_prod[2][i]+=BB[2][i]*half_ex[i+1];
    }
/*    else {
      sp_ex[i] +=BB[2][i]*(2*half_ex[i]-half_ex[i-1]);
      sp_exm[i]+=BB[2][i]*(2*half_exm[i]-half_ex[i-1]);
      E_prod[2][i]+=BB[2][i]*(2*half_ex[i]-half_ex[i-1]);
    } */
    sp_ex[i] += Kr_Ne_Nm - Kcq_Ng*half_ex[i]  - 2*Kiza_ex;
    sp_exm[i]-= Kr_Ne_Nm + Kcq_Ng*half_exm[i] + 2*Kiza_mt;
    E_prod[3][i]+= Kr_Ne_Nm - Kcq_Ng*half_ex[i]  - 2*Kiza_ex;  
    ei_pair[i]+=(Kiza_ex+Kiza_mt)*vol2[i];
    E_prod[0][i]=E_prod[1][i]+E_prod[2][i]+E_prod[3][i];
  }

 /********** A* + A* -> e + A + A^+ ***********/
  for (i=0;i<nc_RT;i++) {
    N_created=0;
    while (ei_pair[i]>=nc2p) {
      N_created++;
      ei_pair[i]-=nc2p;
    }
    for (j=0;j<N_created;j++) { 
      no=np[0];
      r[0][no]=i+(j+1.0)/(N_created+1.0);
      r[0][no]*=nc_ratio;
      maxwellv(&v_r[0][no], &v_theta[0][no], &v_z[0][no], vel);
      no=np[1];
      r[1][no]=i+(j+1.0)/(N_created+1.0);
      r[1][no]*=nc_ratio;
      maxwellv(&v_r[1][no], &v_theta[1][no], &v_z[1][no], vg_therm);
      
   #ifdef MPI_1D
      if (my_rank == ROOT) {
        printf("electron: Vr=%lf, Vth=%lf, Vz=%lf\n",
              v_r[0][np[0]],v_theta[0][np[0]],v_z[0][np[0]]);
        printf("ion: Vr=%lf, Vth=%lf, Vz=%lf\n",
              v_r[1][np[1]],v_theta[1][np[1]],v_z[1][np[1]]);
      }
   #else
      printf("electron: Vr=%lf, Vth=%lf, Vz=%lf\n",
              v_r[0][np[0]],v_theta[0][np[0]],v_z[0][np[0]]);
      printf("ion: Vr=%lf, Vth=%lf, Vz=%lf\n",
              v_r[1][np[1]],v_theta[1][np[1]],v_z[1][np[1]]);
   #endif
   
      if (++np[0]>maxnp[0] || ++np[1]>maxnp[1]) {
      #ifdef MPI_1D
        if (my_rank == ROOT) 
	  puts("ADJUST(E-I PAIRS): too many particles. MUST EXIT!");
      #else
        puts("ADJUST(E-I PAIRS): too many particles. MUST EXIT!");
      #endif
          exit(-1);
      }
    }
  }  
 /************ Radiation Intensity ************/
  for (i=0;i<nc_RT;i++) {
    emission_coeff[i]=sp_ex[i];
    for (j=0;j<nc_RT;j++) emission_coeff[i]-=A[i][j]*sp_ex[j];
  }
  for (i=0;i<nc_RT;i++) {
    radiation_flux[i]=emission_coeff[i]*(i+0.25);
    for (j=0;j<i;j++) radiation_flux[i]+=emission_coeff[j]*(2*j+1.0);
    radiation_flux[i]/=(i+0.5);  	/* 2PI*Dr is multiplied in initwin.c */
  }

  /******** Variation of excited state ********/
  for (i=0;i<nc_RT;i++) {
    error[i]=E_prod[0][i];
    for (j=0;j<nc_RT;j++) error[i]+=AA[i][j]*sp_ex[j];
    if (sp_ex[i]) error[i]/=sp_ex[i];
    else error[i]=0;
  }

  /************ Time History ************/
  if (--count3==0) {
    if (hist_hi3>=HISTMAX) {
      for (i=1, j=4; i<HISTMAX/4; i++, j+=4) {
        error_sum[i]=error_sum[j];
        t_array3[i]=t_array3[j];
        tot_intensity[i]=tot_intensity[j];
      }
      hist_hi3=i;
      interval3*=4;
    }
    t_array3[hist_hi3]=atime;
    error_sum[hist_hi3]=0;
    for (i=0;i<nc_RT;i++) error_sum[hist_hi3]+=fabs(error[i]);
    tot_intensity[hist_hi3]=radiation_flux[nc_RT-1];
    hist_hi3++;

    count3 = interval3;
  }

}
/*******************************************************************/

SCALAR lorentz(SCALAR x)
{
  return(1/(1+x*x));
}
SCALAR doppler(SCALAR x)
{
  return(exp(-x*x));
}
SCALAR voigt(SCALAR x)		/* NOT PREPARED YET */
{
  return(1/(1+x*x));
}


    /********** The integral omega for Diffusion Coeff. ***********/
SCALAR omega(SCALAR x)
{
  int   i;
  SCALAR tstar[27] = {0.250, 0.267, 0.286, 0.308, 0.333, 0.364, 0.400, 0.444,
                     0.500, 0.571, 0.667, 0.800, 1.000, 1.330, 2.000, 2.500,
                     2.860, 3.330, 4.000, 5.000, 6.670, 10.00, 12.50, 16.67,
                     25.00, 50.00, 100.0},
        omega[27] = {1.8714, 1.8344, 1.7962, 1.7560, 1.7142, 1.6702, 1.6238,
                     1.5748, 1.5228, 1.4676, 1.4090, 1.3466, 1.2802, 1.2096,
                     1.1348, 1.1042, 1.0888, 1.0738, 1.0592, 1.0450, 1.0318,
                     1.0198, 1.0154, 1.0112, 1.0072, 1.0034, 1.000};
  SCALAR temp1, temp2=0;

  if      (x<tstar[0])  temp2=omega[0];
  else if (x>tstar[26]) temp2=omega[26];
  else
    for (i=1;i<27;i++)
      if (x<tstar[i]) {
        temp1=(x-tstar[i-1])/(tstar[i]-tstar[i-1]);
        temp2=omega[i]*temp1+omega[i-1]*(1-temp1);
      }
  return(temp2);
}

/*******************************************************************/
void calculate_Akm()
{
  register int i, j, k;
  SCALAR x, k_shape, ri, rju, rjl, temp;

  for (i=0;i<7;i++) {
    I1_l[i] /=pow(3.75,2*i);
    I0_l[i]/=pow(3.75,2*i);
  }
  for (i=0;i<9;i++) {
    I1_u[i] *=pow(3.75,i);
    I0_u[i]*=pow(3.75,i);
  }
  for (i=0;i<7;i++) {
    I0_l[i] /=pow(3.75,2*i);
    I1_l[i]/=pow(3.75,2*i);
  }
  for (i=0;i<7;i++) {
    K0_l[i] /=pow(2.0,2*i);
    K1_l[i]/=pow(2.0,2*i);
  }
  for (i=0;i<7;i++) {
    K0_u[i] *=pow(2.0,i);
    K1_u[i]*=pow(2.0,i);
  }
  /*------------------ frequency integration --------------------*/
  for (i=0;i<nc_RT;i++) {
    for (j=0;j<nc_RT;j++) {
      A[i][j]=0;
      for (k=0;k<=(xbin-1)/2;k++) {
        x=x_array[k];   
        k_shape=k0*k_function(x)*Dr;
        ri=(i+0.5)*k_shape;
        rju=(j+1.0)*k_shape;
        rjl=j*k_shape;
        
        if (i>j) {
          if (rjl<3.75) temp=(phi_integral1(i,j+1,k_shape)-
                              phi_integral1(i,j,k_shape))/M_PI;
          else          temp=bK0I1(ri,rju) - bK0I1(ri,rjl);
        }
        else if (i<j) {
          if (ri <3.75) temp=(phi_integral2(i,j+1,k_shape)-
                              phi_integral2(i,j,k_shape))/M_PI;
          else          temp=aK1I0(rjl,ri) - aK1I0(rju,ri);
        }
        else {
          if (rjl<3.75) temp=(phi_integral2(i,j+1,k_shape)-
                              phi_integral1(i,j,k_shape))/M_PI;
          else          temp= bK0I1(ri,ri) - bK0I1(ri,rjl) 
                            + aK1I0(ri,ri) - aK1I0(rju,ri);
        }
        if (k==0 || k==(xbin-1)/2) temp*=0.5;
        A[i][j]+=temp*k_function(x);
      }                      
      A[i][j]*=2*Cx*dfreqx;
/*      if (fabs(A[i][j])<1e-10) A[i][j]=0;*/
    }
  } 

}

/*******************************************************************/
SCALAR bK0I1(SCALAR a, SCALAR b)
{
  SCALAR result, z, h1, temp, temp2;
  register int i, j;

  z=a-b;
  for (i=0;i<15;i++) K0uI1u[i]=0;
  temp=1;
  for (i=0;i<7;i++) {
    for (j=0;j<9;j++) K0uI1u[i+j]+=K0_u[i]*I1_u[j]*temp;
    temp*=b/a;                                          /* temp=pow(b/a,i) */
  }
  
  {
    /*------- if alpha=beta -------*/
    if (fabs(z)<1e-15) {			
      h1=0.0;
      temp2=b;
      for (i=0;i<15;i++) {
        h1+=K0uI1u[i]/(i+1.0)/temp2;
        temp2*=b;
      }
      result=h1;
    }
    /*------- if alpha>beta -------*/
    else {				
      h1=0.0;
      temp=exp(-z)-z*ei1m(z);			/* when i=0, temp=Ei2(z) */
      temp2=b;
      for (i=0;i<15;i++) {
        h1+=K0uI1u[i]*temp/temp2;
        temp=(exp(-z)-z*temp)/(i+2.0);	/* Ei_j+1(z)=1/j*(exp(-z)-z*Ei_j(z)) */
        temp2*=b;
      }
      result=h1/sqrt(a/b);
    }
  }  

  return (result*b);
}

/*******************************************************************/
SCALAR aK1I0(SCALAR a, SCALAR b)
{
  SCALAR result, z, h1, temp, temp2;
  register int i,j;

  z=a-b;
  for (i=0;i<15;i++) K1uI0u[i]=0;
  temp=1;
  for (i=0;i<7;i++) {
    for (j=0;j<9;j++) K1uI0u[i+j]+=K1_u[i]*I0_u[j]*temp;
    temp*=b/a;                                          /* temp=pow(b/a,i) */
  }
  {
    /*------- if alpha=beta -------*/
    if (fabs(z)<1e-15) {     
      h1=0.0;
      temp2=b;
      for (i=0;i<15;i++) {
        h1+=K1uI0u[i]/(i+1.0)/temp2;
        temp2*=b;
      }
      result=h1;
    }
    /*------- if alpha>beta -------*/
    else {
      h1=0.0;
      temp=exp(-z)-z*ei1m(z);                   /* when i=0, temp=Ei2(z) */
      temp2=b;
      for (i=0;i<15;i++) {
        h1+=K1uI0u[i]*temp/temp2;
        temp=(exp(-z)-z*temp)/(i+2.0);  /* Ei_j+1(z)=1/j*(exp(-z)-z*Ei_j(z)) */
        temp2*=b;
      }
      result=h1/sqrt(a/b);
    }
  }
  return (result*a);
}

/*------------------- With the method I, for k>=m -------------------*/
SCALAR phi_integral1(int k, int m, SCALAR k0kx)    
{
  register int i;
  SCALAR theta_max, dtheta, theta, ha, hb, result=0;
  int   Nmax=256;
 
  if (m==0) return(0);

  theta_max=asin(m/r_grid2[k]);
  Nmax*=theta_max/M_PI;
  if (Nmax<64) Nmax=64;
  dtheta=theta_max/(SCALAR)Nmax;
  for (i=1;i<Nmax;i++) {
     theta=dtheta*i;
     ha=r_grid2[k]*cos(theta)+sqrt(m*m-pow(r_grid2[k]*sin(theta),2));
     hb=r_grid2[k]*cos(theta)-sqrt(m*m-pow(r_grid2[k]*sin(theta),2));
     result+= Ki2(k0kx*hb)-Ki2(k0kx*ha);
  }  
  ha=r_grid2[k]+m;
  hb=r_grid2[k]-m;
  result += 0.5*(Ki2(k0kx*hb)-Ki2(k0kx*ha));
  result *= dtheta;
/*  printf("C %e %lf %lf %e %e\n",k0kx,ha,hb,dtheta,result); */
  return(result);
}

/*------------------- With the method I, for k<m --------------------*/
SCALAR phi_integral2(int k, int m, SCALAR k0kx)    
{
  register int i;
  SCALAR theta_max, dtheta, theta, ha, result=0;
  int   Nmax=256;
  
  theta_max=M_PI;
  dtheta=theta_max/(SCALAR)Nmax;
  for (i=1;i<Nmax;i++) {
     theta=dtheta*i;
     ha=r_grid2[k]*cos(theta)+sqrt(m*m-pow(r_grid2[k]*sin(theta),2));
     result+= 1-Ki2(k0kx*ha);
  }
  ha=r_grid2[k]+m;
  result+= 0.5*(1-Ki2(k0kx*ha));
  ha=-r_grid2[k]+m;
  result+= 0.5*(1-Ki2(k0kx*ha));
  result*= dtheta;
/*  printf("%e %e\n",k0kx,result); */
  return(result);
}


/*******************************************************************/

SCALAR ei1m(SCALAR z)
{
  SCALAR a0,a1,a2,a3,a4,a5, b1,b2,b3,b4, ei1;

/*  if (z<=0) {
    puts("Ei1(z) function cannot be evaluated for z<=0");
    exit(-1);
  }*/

  if (z<1) {
    a0=-0.57721566; a1=0.99999193;
    a2=-0.24991055; a3=0.05519968;
    a4=-0.00976004; a5=0.00107857;
    ei1=a0+z*(a1+z*(a2+z*(a3+z*(a4+z*a5)))) - log(z);
  }
  else {
    a1=8.5733287401; a2=18.0590169730;
    a3=8.6347608925; a4=0.2677737343;
    b1=9.5733223454; b2=25.6329561486;
    b3=21.0996530827; b4=3.9584969228;
    ei1=exp(-z)/z*(a4+z*(a3+z*(a2+z*(a1+z))))/(b4+z*(b3+z*(b2+z*(b1+z))));
  }
  return (ei1);
}

SCALAR GE0(SCALAR z) 			/* GE0(z) = sqrt(PI)*erfc(sqrt(z)) */
{
  SCALAR t, result;
/*---------------------- epsilon < 1.5e-7 ----------------------*
  t=1.0/(1+0.3275911*sqrt(z));
  result = t*(0.254829592 +t*(-0.284496736 + t*(1.421413741 + t*(-1.453152027 
         + t*1.061405429))))*exp(-z);
*/
/*---------------------- epsilon < 2.5e-5 ----------------------*/
  t=1.0/(1+0.47047*sqrt(z));
  result = t*(0.3480242 + t*(-0.0958798 + t*0.7478556))*exp(-z);

  return (sqrt(M_PI)*result); 
}
      
/* for GNU Plot
Error Function for x>0, 
plot 1.0/(1+0.3275911*x)*(0.254829592 +1.0/(1+0.3275911*x)*(-0.284496736 + 1.0/(1+0.3275911*x)*(1.421413741 + 1.0/(1+0.3275911*x)*(-1.453152027 + 1.0/(1+0.3275911*x)*1.061405429))))*exp(-x*x), 1.0/(1+0.47047*x)*(0.3480242 + 1.0/(1+0.47047*x)*(-0.0958798 + 1.0/(1+0.47047*x)*0.7478556))*exp(-x*x)
*/

SCALAR J0(SCALAR x)
{
  SCALAR y, theta0, result;
  if (x<3) {
    y=x/3;
    y*=y;
    result= 1.0 + y*(-2.2499997 + y*(1.2656208 + y*(-0.3163866 + y*(0.0444479 +
                  y*(-0.0039444 + y*0.0002100)))));
  }
  else {
    y=3./x;
    theta0= x - 0.78539816 + y*(-0.04166397 + y*(-0.00003954 + y*(0.00262573 +
            y*(-0.00054125 + y*(-0.00029333 + y*0.00013558)))));
    result= cos(theta0)*(0.79788456 + y*(-0.00000077 + y*(-0.00552740 +
            y*(-0.00009512 +y*(0.00137237 + y*(-0.00072805 + y*0.00014476))))))
            /sqrt(x);
  }
  return (result);
}

/***************************************************************/
SCALAR Ki2(SCALAR z)
{
  SCALAR result;

  if (z<1e-9) result = 1.0;
  else if (z>30) result=0;
  else         result = zK1(z)-z*exp(-z)*Ki1(z);
  return (result);
}

SCALAR Ki1(SCALAR z)				/* exp(z) Ki1(z) */
/* This function computes the second repeated integral of
   the modified Bessel function second kind, zero order
   by means of a recursion formula (see Abramowitz)      */
{
  SCALAR result, t, u, h1, tsq;

  if (z<1e-12) result=M_PI/2;
  else if (z<1.0) {
    t=z/2;
    tsq=t*t;
    u=log(t)+0.5772156649;
    h1=(1-u) + tsq*( (4.0/9.0-u/3.0) + tsq*( (0.085-0.05*u) +
       tsq*( (0.007842025-u/252.0) + tsq*(4.23311036e-4 - u/5184.0) )));
    result=(-2*t*h1+M_PI/2)*exp(z);
  }
  else if (z<3.8) {
    t=1/z;
    result=1.0/sqrt(z)*(1.23711091 +t*(-0.62015283 + t*(0.44927294 +
           t*(-0.23121965 + t*(0.11001445 + t*(-0.09732933 + t*0.04438948))))));
  }
  else {
    t=7.0/z;
    result=1.0/sqrt(z)*(1.25331414 + t*(-0.11190289 + t*(0.02576646 +
           t*(-0.00933994 + t*(0.00417454 + t*(-0.00163271 + t*0.00033934))))));
  }
  return (result);
}

SCALAR zK1(SCALAR z)                              /* exp(z) Ki-1(z) */
{
  SCALAR t, result;

  if (z<2) {
    t=z/2.0;
    t*=t;
    result= z*log(z/2.0)*I1(z) + 1 + t*(0.15443144 + t*(-0.67278579 +
        t*(-0.18156897 + t*(-0.01919402 + t*(-0.00110404 - t*0.00004686)))));
  }
  else {
    t=2.0/z;
    result=exp(-z)*sqrt(z)*( 1.25331414 + t*(0.23498619 + t*(-0.03655620 +
           t*(0.01504268 + t*(-0.00780353 + t*(0.00325614 - t*0.00068245) )))));
  }
  return (result);
}

SCALAR I1(SCALAR z)
{
  SCALAR t, result;
  if (z<=3.75) {
    t=z/3.75;
    t*=t;
    result= z*(0.5 + t*(0.87890594 + t*(0.51498869 + t*(0.15084934 +
               t*(0.02658733 + t*(0.00301532 + t*0.00032411))))));
  }
  else {
    t=3.75/z;
    result= exp(z)/sqrt(z)*(0.39894228 + t*(-0.03988024 + t*(-0.00362018 +
           t*(0.00163801 +t*(-0.01031555 + t*(0.02282967 + t*(-0.02895312 +
           t*(0.01787654 - t*0.00420059))))))));
  }
  return (result);
}

